Attribute VB_Name = "ZZZ_ApplyAllDoc"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' IPress (C) 2001,2002,2003 Estndard Lingstic S.L.
'   versi 1.1rev7
'   Concepte i diseny per Ricard Prez
'   Programat per Gerardo Garca
'   Tots els drets reservats.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Public Function ApplyFirstSecondOptionAllDoc(ByVal appop As String, _
                                             ByRef rngsrchst As Long, _
                                             ByRef rngsrched As Long, _
                                             ByRef rngsrchnx As Long, _
                                             ByVal rngsrchsz As Long, _
                                             ByVal type_def As String, _
                                             ByRef do_substitution As Boolean) As Boolean
  Dim rngsearch As Range
  Dim strsearch As String
  Dim fin As Boolean
  
  ' Componemos el string de busqueda
  strsearch = type_def & appop
  If Right(type_def, 1) = "'" Then
    strsearch = strsearch & "'"
  End If
  
  ' Buscamos a pion la opcin
  Set rngsearch = ActiveDocument.Range(rngsrchst, rngsrchsz)
  With rngsearch.Find
    .ClearFormatting
    .Text = strsearch
    .Replacement.Text = ""
    .Forward = True
    .Wrap = wdFindStop
    .Format = False
    .MatchCase = True
    .MatchWholeWord = False
    .MatchWildcards = False
    .MatchSoundsLike = False
    .MatchAllWordForms = False
  End With
  
  If rngsearch.Find.Execute Then
    ' Hemos encontrado algo, sea bueno o no. Debemos decir que todavia podemos
    ' buscar ms!
    fin = False
    ' Marcamos donde estamos para hacer descarado que almenos trabajamos.
    rngsearch.Select
    ' En un arrebato de optimismo desmesurado osamos a aceptar de entrada
    ' un buen futuro para todos nuestros esfuerzos (ilusos)
    do_substitution = True
    ' Nos aseguramos de que la opcin es exactamente la que buscamos, es decir,
    ' si estamos buscando *ajo y encontramos **ajo, este ltimo no lo consideraremos
    ' un objetivo a substituir
    If rngsearch.Start > 1 Then
      do_substitution = ActiveDocument.Range(rngsearch.Start - 1, rngsearch.Start).Text <> "*"
    End If
    ' Nos aseguramos que la opcin termina justo donde debiera, sino fuese
    ' as, podra sr que sustituyendo por ejemplo *comp, tambien nos cargsemos
    ' cosas como *compression
    If do_substitution Then
      If rngsearch.End + 1 <= rngsrchsz Then
        do_substitution = Not ZZZ_IsLectehr(ActiveDocument.Range(rngsearch.End, rngsearch.End + 1).Text)
        'MsgBox Asc(ActiveDocument.Range(rngsearch.End, rngsearch.End + 1).Text) & " = " & ActiveDocument.Range(rngsearch.End, rngsearch.End + 1).Text
      Else
        do_substitution = True
      End If
    End If
    ' Sea aceptable, lo encontrado, o no, devolvemos la ubicacin e instrucciones
    ' para saltarnos a la torera la opcin
    rngsrchst = rngsearch.Start
    rngsrched = rngsearch.End
    rngsrchnx = rngsearch.End
  Else
    ' Si no lo hemos encontrado, decimos que pare de dar vueltas al bucle,
    ' que no va a aparecer.
    fin = True
  End If
  
  ' Espero que con esto se fuerce a liberar memoria
  Set rngsearch = Nothing
  
  ApplyFirstSecondOptionAllDoc = fin
End Function

Public Function ApplyForthOptionAllDoc(ByVal appop As String, _
                                       ByRef rngsrchst As Long, _
                                       ByRef rngsrched As Long, _
                                       ByRef rngsrchnx As Long, _
                                       ByVal rngsrchsz As Long, _
                                       ByVal type_def As String, _
                                       ByRef do_substitution As Boolean) As Boolean
  Dim rngsearch As Range
  Dim strsearch As String
  Dim fin As Boolean
  Dim found_st As Long, found_ed As Long
  Dim col As Collection
  Dim i As Integer
  
  ' Comenzamos con un pesimismo extremo, es decir, diciendo que todo debera acabar
  ' y dejndolo como inutil
  fin = True
  do_substitution = False

  ' Componemos el string de busqueda "appop//" y buscamos a pion la opcin
  Set rngsearch = ActiveDocument.Range(rngsrchst, rngsrchsz)
  With rngsearch.Find
    .ClearFormatting
    .Text = appop & "//"
    .Replacement.Text = ""
    .Forward = True
    .Wrap = wdFindStop
    .Format = False
    .MatchCase = True
    .MatchWholeWord = False
    .MatchWildcards = False
    .MatchSoundsLike = False
    .MatchAllWordForms = False
  End With
  If rngsearch.Find.Execute Then
    If fin Or rngsearch.Start < found_st Then
      found_st = rngsearch.Start
      found_ed = rngsearch.End
      strsearch = "1"
      fin = False
    End If
  End If
  Set rngsearch = Nothing
  ' Componemos el string de busqueda " appop " y buscamos a pion la opcin
  Set rngsearch = ActiveDocument.Range(rngsrchst, rngsrchsz)
  With rngsearch.Find
    .ClearFormatting
    .Text = "//" & appop & "///"
    .Replacement.Text = ""
    .Forward = True
    .Wrap = wdFindStop
    .Format = False
    .MatchCase = True
    .MatchWholeWord = False
    .MatchWildcards = False
    .MatchSoundsLike = False
    .MatchAllWordForms = False
  End With
  If rngsearch.Find.Execute Then
    If fin Or rngsearch.Start < found_st Then
      found_st = rngsearch.Start
      found_ed = rngsearch.End
      strsearch = "2"
      fin = False
    End If
  End If
  Set rngsearch = Nothing
  
  ' Si fin ha pasado a ser False quiere decir que se encontro algo
  If Not fin Then
    ' Ahora es ver que tipo de busqueda hicimos, y si no estamos al principio de la
    ' opcin debemos buscarlo.
    
    ' Si comienza la busqueda por { quiere decir que ya estamos al principio de
    ' la opcin, en otro caso, buscamos el posible principio de la opcin
    If strsearch = "1" Then
      found_st = found_st + Len(appop)
    End If
      
    ' Para terminar de asegurarnos, debemos parsear la opcin.
    ' Con esto delimitamos nuestra zona de trabajo y garantizamos que es una
    ' alternativa que podemos sustituir
    Selection.Start = found_st
    Selection.End = found_st
    Set col = ZZZ_ParseCuartaOp(found_st, rngsrched, type_def)
    ' Si hemos encontrado algo...
    If col.Count > 0 Then
      ' Comprobamos que lo que buscamos este entre las opciones
      do_substitution = False
      For i = 1 To col.Count
        do_substitution = do_substitution Or (col(i) = appop)
      Next i
      If do_substitution Then
        rngsrchst = found_st
        ' La variable 'rngsrched' ya se ajustado en el parsing
        rngsrchnx = found_ed
      End If
    Else
      ' Al parecer no es una alternativa valida, a s que proponemos saltarnosla
      do_substitution = False
    End If
    
    If Not do_substitution Then
      ' Al parecer no es una alternativa valida, a s que proponemos saltarnosla
      rngsrched = found_ed
      rngsrchnx = found_ed
    End If
  End If
  
  ApplyForthOptionAllDoc = fin
End Function

Public Function ApplyThirdOrFifthOptionAllDoc(ByVal appop As String, _
                                              ByRef rngsrchst As Long, _
                                              ByRef rngsrched As Long, _
                                              ByRef rngsrchnx As Long, _
                                              ByVal rngsrchsz As Long, _
                                              ByVal type_def As String, _
                                              ByRef do_substitution As Boolean) As Boolean
  Dim rngsearch As Range
  Dim strsearch As String
  Dim fin As Boolean
  Dim found_st As Long, found_ed As Long
  Dim col As Collection
  Dim i As Integer
  Dim open_sign As String, close_sign As String, sep_sign As String
  
  If Left(type_def, 1) = "{" Then
    open_sign = "{"
    close_sign = "}"
    sep_sign = ";"
  Else
    open_sign = "["
    close_sign = "]"
    sep_sign = "|"
  End If
  
  ' Comenzamos con un pesimismo extremo, es decir, diciendo que todo debera acabar
  ' y dejndolo como inutil
  fin = True
  do_substitution = False

  ' Componemos el string de busqueda "appop" y buscamos a pion la opcin
  Set rngsearch = ActiveDocument.Range(rngsrchst, rngsrchsz)
  With rngsearch.Find
    .ClearFormatting
    .Text = appop
    .Replacement.Text = ""
    .Forward = True
    .Wrap = wdFindStop
    .Format = False
    .MatchCase = True
    .MatchWholeWord = False
    .MatchWildcards = False
    .MatchSoundsLike = False
    .MatchAllWordForms = False
  End With
  If rngsearch.Find.Execute Then
    rngsearch.Select
    fin = False
    If rngsearch.End < rngsrchsz Then
      If (Not do_substitution) And (rngsearch.Start > 0) Then
        'MsgBox ">>'" & ActiveDocument.Range(rngsearch.Start - 1, rngsearch.Start).Text & "'  >>'" & ActiveDocument.Range(rngsearch.End, rngsearch.End + 1).Text & "'"
        If ActiveDocument.Range(rngsearch.Start - 1, rngsearch.Start).Text = open_sign And _
           ActiveDocument.Range(rngsearch.End, rngsearch.End + 1).Text = " " Then
          found_st = rngsearch.Start - 1
          found_ed = rngsearch.End + 1
          strsearch = open_sign & appop & " "
          do_substitution = True
        End If
      End If
      If (Not do_substitution) And (rngsearch.Start > 1) And (rngsearch.End + 1 < rngsrchsz) Then
        'MsgBox ">>'" & ActiveDocument.Range(rngsearch.Start - 2, rngsearch.Start - 1).Text & ActiveDocument.Range(rngsearch.Start - 1, rngsearch.Start).Text & "'  >>'" & ActiveDocument.Range(rngsearch.End, rngsearch.End + 1).Text & ActiveDocument.Range(rngsearch.End + 1, rngsearch.End + 2).Text & "'"
        If ActiveDocument.Range(rngsearch.Start - 2, rngsearch.Start - 1).Text = sep_sign And _
           ActiveDocument.Range(rngsearch.Start - 1, rngsearch.Start).Text = " " And _
           ActiveDocument.Range(rngsearch.End, rngsearch.End + 1).Text = " " And _
           ActiveDocument.Range(rngsearch.End + 1, rngsearch.End + 2).Text = sep_sign Then
          found_st = rngsearch.Start - 2
          found_ed = rngsearch.End + 2
          strsearch = " " & appop & " "
          do_substitution = True
        End If
      End If
      If (Not do_substitution) And (rngsearch.Start > 0) Then
        'MsgBox ">>'" & ActiveDocument.Range(rngsearch.Start - 1, rngsearch.Start).Text & "'  >>'" & ActiveDocument.Range(rngsearch.End, rngsearch.End + 1).Text & "'"
        If ActiveDocument.Range(rngsearch.Start - 1, rngsearch.Start).Text = " " And _
           ActiveDocument.Range(rngsearch.End, rngsearch.End + 1).Text = close_sign Then
          found_st = rngsearch.Start - 1
          found_ed = rngsearch.End + 1
          strsearch = " " & appop & close_sign
          do_substitution = True
        End If
      End If
    End If
    ' Si 'do_substitution' es falso, quiere decir que nos han engaado!
    If Not do_substitution Then
      found_st = rngsearch.Start
      found_ed = rngsearch.End
    End If
    'Selection.Start = found_st
    'Selection.End = found_ed
    'MsgBox "do_substitution = " & do_substitution & "  [" & found_st & ", " & found_ed & "]"
  End If
  Set rngsearch = Nothing
  
  ' Si se encontro algo (do_substitution) sera bueno procesarlo,
  ' si en cambio no, tendremos que almenos actualizar el salto por
  ' encima de esto que nos ha engaado!
  If Not fin And do_substitution Then
    ' Ahora es ver que tipo de busqueda hicimos, y si no estamos al principio de la
    ' opcin debemos buscarlo.
    
    ' Si comienza la busqueda por { quiere decir que ya estamos al principio de
    ' la opcin, en otro caso, buscamos el posible principio de la opcin
    If Left(strsearch, 1) <> open_sign Then
      Set rngsearch = ActiveDocument.Range(0, found_st)
      With rngsearch.Find
        .ClearFormatting
        .Text = open_sign
        .Replacement.Text = ""
        .Forward = False
        .Wrap = wdFindStop
        .Format = False
        .MatchCase = True
        .MatchWholeWord = False
        .MatchWildcards = False
        .MatchSoundsLike = False
        .MatchAllWordForms = False
      End With
      do_substitution = rngsearch.Find.Execute
      ' Si la llave encontrada esta antes de 'rngsrch_st' quiere decir que nos
      ' hemos ido de baretas, y por lo tanto no hace falta seguir con la busqueda.
      do_substitution = do_substitution And (rngsearch.Start >= rngsrchst)
      ' Ahora si todo ha ido bien, actualizamos 'found_st'
      found_st = rngsearch.Start
      ' Espero que con esto se fuerce a liberar memoria
      Set rngsearch = Nothing
    Else
      do_substitution = True
    End If
    
    If do_substitution Then
      ' Para terminar de asegurarnos, debemos parsear la opcin.
      ' Con esto delimitamos nuestra zona de trabajo y garantizamos que es una
      ' alternativa que podemos sustituir
      Selection.Start = found_st
      'Selection.End = found_ed
      'MsgBox "aqui"
      Selection.End = found_st
      If Left(type_def, 1) = "{" Then
        Set col = ZZZ_ParseTerceraOp(rngsrched, type_def)
      Else
        Set col = ZZZ_ParseQuintaOp(rngsrched, type_def)
      End If
      ' Si hemos encontrado algo...
      If col.Count > 0 Then
        ' Comprobamos que lo que buscamos este entre las opciones
        do_substitution = False
        For i = 1 To col.Count
          do_substitution = do_substitution Or (col(i) = appop)
        Next i
        If do_substitution Then
          rngsrchst = found_st
          ' La variable 'rngsrched' ya se ajustado en el parsing
          rngsrchnx = found_ed
        End If
      Else
        ' Al parecer no es una alternativa valida, a s que proponemos saltarnosla
        do_substitution = False
      End If
    End If
    If Not do_substitution Then
      ' Al parecer no es una alternativa valida, a s que proponemos saltarnosla
      rngsrched = found_ed
      rngsrchnx = found_ed
    End If
  Else
    If Not fin Then
      ' Al parecer lo que encontramos no era bueno. Lo saltamos.
      rngsrched = found_ed
      rngsrchnx = found_ed
    End If
  End If
  
  ApplyThirdOrFifthOptionAllDoc = fin
End Function


Public Sub ApplyOptionAllDoc(ByVal appop As String, ByVal appopsubs As String, ByVal auto As Boolean, ByVal def_alt As String)
  Dim do_substitution As Boolean, fin As Boolean
  Dim rngsrchst As Long, rngsrchnx As Long, rngsrched As Long, rngsrchsz As Long
  Dim parr_act As Long, parr_ini_pos As Long, ini_pos As Long
  Dim total As Long
  Dim j As Integer
  Dim rngsearch As Range
  Dim ziwc_posx As Integer, ziwc_posy As Integer
  Dim borrar_izq As Boolean, borrar_der As Boolean
  Dim type_alt As String
  
    ' Inicialmente ponemos la ventanita que preguntara en medio
    ' la pantalla, donde ms fastidie
  ziwc_posx = ziwc_posy = -1
  
    ' Guardamos el parrafo donde comenzamos a hacer cosas
  Set rngsearch = ActiveDocument.Range(0, Selection.Start)
  parr_act = rngsearch.Paragraphs.Count
  Set rngsearch = Nothing
    ' Guardamos la posicin donde comenzamos a hacer cosas
  parr_ini_pos = ActiveDocument.Paragraphs(parr_act).Range.Start
  ini_pos = Selection.Start
  
    ' Nos situamos al principio del documento
  Selection.Start = 0
  Selection.End = 0
  
    ' Nos preparamos solo para ir a por un tipo de alternativas
  type_alt = Left(def_alt, 1)
  
    ' Nos preparamos y comenzamos el bucle de ataque
  total = 1
  rngsrchst = 0
  
  fin = False
  While Not fin
    borrar_izq = False
    borrar_der = False
      ' Averiguamos las dimensiones del documento
    Set rngsearch = ActiveDocument.Range
    rngsearch.WholeStory
    rngsrchsz = rngsearch.End
    Set rngsearch = Nothing
    If rngsrchst < rngsrchsz Then
        ' Buscamos la palabrita segn el tipo de opcin
      If type_alt = "*" Then
        fin = ApplyFirstSecondOptionAllDoc(appop, rngsrchst, rngsrched, rngsrchnx, rngsrchsz, def_alt, do_substitution)
      ElseIf type_alt = "{" Then
        fin = ApplyThirdOrFifthOptionAllDoc(appop, rngsrchst, rngsrched, rngsrchnx, rngsrchsz, def_alt, do_substitution)
      ElseIf type_alt = "/" Then
        fin = ApplyForthOptionAllDoc(appop, rngsrchst, rngsrched, rngsrchnx, rngsrchsz, def_alt, do_substitution)
      ElseIf type_alt = "[" Then
        fin = ApplyThirdOrFifthOptionAllDoc(appop, rngsrchst, rngsrched, rngsrchnx, rngsrchsz, def_alt, do_substitution)
      Else
        MsgBox "IPress Panic: Opci '" + type_alt + "' desconeguda!", vbCritical, "IPress Assistant Error"
        fin = True
      End If
      
      ' Si hemos salido airosos de la busqueda, y encima hay algo que substituir,
      ' entonces nos lanzamos a por ello
      If Not fin And do_substitution Then
        ' Como damos la opcion como parseada, validada y molona simplemente nos
        ' limitamos a sustituir el carro que gentilmente nos han marcado por
        ' el valor de 'appopsubs'
        
        Selection.Start = rngsrchst
        Selection.End = rngsrched
        
        ' Si no estamos en modo automtico es necesario saber la opinin del
        ' usuario, as que sacamos una ventanita preguntona y descarada
        If Not auto Then
          ZZZ_IPressWindowChange.palabro = appopsubs
          ZZZ_IPressWindowChange.posx = ziwc_posx
          ZZZ_IPressWindowChange.posy = ziwc_posy
          ZZZ_IPressWindowChange.Show
          j = ZZZ_IPressWindowChange.respuesta
          borrar_izq = ZZZ_IPressWindowChange.suprizq.Value
          borrar_der = ZZZ_IPressWindowChange.suprder.Value
          ziwc_posx = ZZZ_IPressWindowChange.posx
          ziwc_posy = ZZZ_IPressWindowChange.posy
          Set ZZZ_IPressWindowChange = Nothing
          do_substitution = (j = 2)
          fin = (j = 0)
        End If
        
        ' Si el usuario ha aprobado la sustitucin, o simplemente, estamos en modo
        ' automtico, realizamos una sustitucin sin piedad alguna
        If do_substitution Or auto Then
          ' Si tenemos que borrar un espacio a la derecha, lo seleccionamos!
          If borrar_der And Selection.End <= rngsrchsz Then
            If ActiveDocument.Range(Selection.End, Selection.End + 1) = " " Then
              Selection.End = Selection.End + 1
            End If
          End If
          ' Si tenemos que borrar un espacio a la izquierda, lo seleccionamos!
          If borrar_izq And Selection.Start > 0 Then
            If ActiveDocument.Range(Selection.Start - 1, Selection.Start) = " " Then
              Selection.Start = Selection.Start - 1
            End If
          End If
          ' Tenemos la seleccin hecha y muchas ganas de sustituir
          Options.ReplaceSelection = True
          Selection.TypeText appopsubs
          total = total + 1
          rngsrchst = Selection.Start
          rngsrched = rngsrchst
          rngsrchnx = rngsrchst
        Else
          ' El usuario ha decido saltarse esta palabra, simplemente, cogemos
          ' y delimitamos la busqueda justo donde acaba esta seleccin (o palabra)
          ' y avanzamos a la siguiente.
          rngsrchst = rngsrchnx
        End If
      Else
        rngsrchst = rngsrchnx
      End If
    Else
      fin = True
    End If
  Wend

    ' Volvemos a la posicin donde lo dejamos
  If parr_act < ActiveDocument.Paragraphs.Count Then
      ' Comprobamos la validez de ini_pos respecto a parr_ini_pos
    If ini_pos > parr_ini_pos Then
      ini_pos = ini_pos - parr_ini_pos
    Else
      ini_pos = 0
    End If
      ' Recalculamos la posicion donde lo dejamos...
    ini_pos = ini_pos + ActiveDocument.Paragraphs(parr_act).Range.Start
      ' Averiguamos las dimensiones del documento
    Set rngsearch = ActiveDocument.Range
    rngsearch.WholeStory
    rngsrchsz = rngsearch.End
    Set rngsearch = Nothing
      ' Comprobamos que el offset calculado sea correcto
    If ini_pos > rngsrchsz Then
      ini_pos = 0
    End If
  Else
      ' Panico! El numero de parrafos a cambiado?
    ini_pos = 0
  End If
  
    ' Nos reubicamos donde dejamos la historia anterior!
  Selection.Start = ini_pos
  Selection.End = ini_pos

  If total > 1 Then
    MsgBox "S'han fet " & total & " substitucions.", vbInformation, "IPress Assistant"
  Else
    MsgBox "No s'ha fet cap ms substituci d'aquesta alternativa en el text.", vbInformation, "IPress Assistant"
  End If
End Sub

